summaryrefslogtreecommitdiff
path: root/oh-my-zsh/plugins/svn-fast-info
diff options
context:
space:
mode:
authorAditya <bluenerd@protonmail.com>2023-02-27 20:04:56 +0530
committerAditya <bluenerd@protonmail.com>2023-02-27 20:04:56 +0530
commitedc449275b6c04445f58b108ca0937a87c1e8430 (patch)
tree9fd484d58145b616f29a78857cc0b1c8b1c18f05 /oh-my-zsh/plugins/svn-fast-info
parent6f5424ca96c4221ef433f545642669e9c104d0ed (diff)
add zsh
Diffstat (limited to 'oh-my-zsh/plugins/svn-fast-info')
-rw-r--r--oh-my-zsh/plugins/svn-fast-info/README.md56
-rw-r--r--oh-my-zsh/plugins/svn-fast-info/svn-fast-info.plugin.zsh74
2 files changed, 130 insertions, 0 deletions
diff --git a/oh-my-zsh/plugins/svn-fast-info/README.md b/oh-my-zsh/plugins/svn-fast-info/README.md
new file mode 100644
index 0000000..e86ba21
--- /dev/null
+++ b/oh-my-zsh/plugins/svn-fast-info/README.md
@@ -0,0 +1,56 @@
+# svn-fast-info plugin
+
+Faster alternative to the main SVN plugin implementation. Works with svn 1.6 and newer.
+Use as a drop-in replacement to the svn plugin, not as complementary.
+
+To use it, add `svn-fast-info` to the plugins array in your zshrc file:
+
+```zsh
+plugins=(... svn-fast-info)
+```
+
+It's faster because it has an efficient use of svn (single svn call) which saves a lot on a huge codebase.
+It displays the current status of the local files (added, deleted, modified, replaced, or else...)
+
+Use `svn_prompt_info` method to display the svn repository status in your theme.
+
+## Functions
+
+- `svn_prompt_info`: displays all the available information regarding the status of the svn repository.
+
+- `svn_repo_need_upgrade`: shows whether the repository needs upgrading. `svn_prompt_info` queries the
+ rest of functions or not based on the result of this function.
+
+- `svn_current_branch_name`: shows the current branch.
+
+- `svn_repo_root_name`: displays the repository root.
+
+- `svn_current_revision`: shows the currently checked-out revision.
+
+- `svn_status_info`: shows a bunch of symbols depending on the status of the files in the repository.
+
+## Options
+
+- `ZSH_THEME_SVN_PROMPT_PREFIX`: sequence displayed at the beginning of the prompt info output.
+
+- `ZSH_THEME_SVN_PROMPT_SUFFIX`: sequence displayed at the end of the prompt info output.
+
+- `ZSH_THEME_SVN_PROMPT_CLEAN`: sequence displayed when the status of the repository is clean.
+
+- `ZSH_THEME_SVN_PROMPT_ADDITIONS`: sequence displayed if there are added files in the repository.
+ **Default:** `+`.
+
+- `ZSH_THEME_SVN_PROMPT_DELETIONS`: sequence displayed if there are deleted files in the repository.
+ **Default:** `✖`.
+
+- `ZSH_THEME_SVN_PROMPT_MODIFICATIONS`: sequence displayed if there are modified files in the repository.
+ **Default:** `✎`.
+
+- `ZSH_THEME_SVN_PROMPT_REPLACEMENTS`: sequence displayed if there are replaced files in the repository.
+ **Default:** `∿`.
+
+- `ZSH_THEME_SVN_PROMPT_UNTRACKED`: sequence displayed if there are untracked files in the repository.
+ **Default:** `?`.
+
+- `ZSH_THEME_SVN_PROMPT_DIRTY`: sequence displayed if the repository is dirty.
+ **Default:** `!`.
diff --git a/oh-my-zsh/plugins/svn-fast-info/svn-fast-info.plugin.zsh b/oh-my-zsh/plugins/svn-fast-info/svn-fast-info.plugin.zsh
new file mode 100644
index 0000000..46dd5cb
--- /dev/null
+++ b/oh-my-zsh/plugins/svn-fast-info/svn-fast-info.plugin.zsh
@@ -0,0 +1,74 @@
+function svn_prompt_info() {
+ local info
+ info=$(LANG= svn info 2>&1) || return 1 # capture stdout and stderr
+ local repo_need_upgrade=$(svn_repo_need_upgrade $info)
+
+ if [[ -n $repo_need_upgrade ]]; then
+ printf '%s%s%s%s%s%s%s\n' \
+ "$ZSH_PROMPT_BASE_COLOR" \
+ "$ZSH_THEME_SVN_PROMPT_PREFIX" \
+ "$ZSH_PROMPT_BASE_COLOR" \
+ "$repo_need_upgrade" \
+ "$ZSH_PROMPT_BASE_COLOR" \
+ "$ZSH_THEME_SVN_PROMPT_SUFFIX" \
+ "$ZSH_PROMPT_BASE_COLOR"
+ else
+ printf '%s%s%s%s %s%s%s:%s%s%s%s' \
+ "$ZSH_PROMPT_BASE_COLOR" \
+ "$ZSH_THEME_SVN_PROMPT_PREFIX" \
+ "$(svn_status_info $info)" \
+ "$ZSH_PROMPT_BASE_COLOR" \
+ \
+ "$ZSH_THEME_BRANCH_NAME_COLOR" \
+ "${$(svn_current_branch_name $info):gs/%/%%}" \
+ "$ZSH_PROMPT_BASE_COLOR" \
+ \
+ "$(svn_current_revision $info)" \
+ "$ZSH_PROMPT_BASE_COLOR" \
+ "$ZSH_THEME_SVN_PROMPT_SUFFIX" \
+ "$ZSH_PROMPT_BASE_COLOR"
+ fi
+}
+
+function svn_repo_need_upgrade() {
+ command grep -q "E155036" <<< "${1:-$(LANG= svn info 2>/dev/null)}" && \
+ echo "E155036: upgrade repo with svn upgrade"
+}
+
+function svn_current_branch_name() {
+ omz_urldecode "$(
+ command grep '^URL:' <<< "${1:-$(svn info 2>/dev/null)}" | command grep -Eo '(tags|branches)/[^/]+|trunk'
+ )"
+}
+
+function svn_repo_root_name() {
+ command grep '^Repository\ Root:' <<< "${1:-$(LANG= svn info 2>/dev/null)}" | sed 's#.*/##'
+}
+
+function svn_current_revision() {
+ echo "${1:-$(LANG= svn info 2>/dev/null)}" | sed -n 's/Revision: //p'
+}
+
+function svn_status_info() {
+ local svn_status_string="$ZSH_THEME_SVN_PROMPT_CLEAN"
+ local svn_status="$(svn status 2>/dev/null)";
+ if command grep -E '^\s*A' &>/dev/null <<< "$svn_status"; then
+ svn_status_string+="${ZSH_THEME_SVN_PROMPT_ADDITIONS:-+}"
+ fi
+ if command grep -E '^\s*D' &>/dev/null <<< "$svn_status"; then
+ svn_status_string+="${ZSH_THEME_SVN_PROMPT_DELETIONS:-✖}"
+ fi
+ if command grep -E '^\s*M' &>/dev/null <<< "$svn_status"; then
+ svn_status_string+="${ZSH_THEME_SVN_PROMPT_MODIFICATIONS:-✎}"
+ fi
+ if command grep -E '^\s*[R~]' &>/dev/null <<< "$svn_status"; then
+ svn_status_string+="${ZSH_THEME_SVN_PROMPT_REPLACEMENTS:-∿}"
+ fi
+ if command grep -E '^\s*\?' &>/dev/null <<< "$svn_status"; then
+ svn_status_string+="${ZSH_THEME_SVN_PROMPT_UNTRACKED:-?}"
+ fi
+ if command grep -E '^\s*[CI!L]' &>/dev/null <<< "$svn_status"; then
+ svn_status_string+="${ZSH_THEME_SVN_PROMPT_DIRTY:-!}"
+ fi
+ echo $svn_status_string
+}